FUNCTION do-on-event-tests-1 RETURNS LOGICAL ():
   DISPLAY "A: Triggers test 1: ON <db-event>" SKIP.

   DEFINE VARIABLE i AS INTEGER INIT 0.
   
   /* trigger will not fire, not yet installed */
   FIND FIRST customer.
   DISPLAY "first =" customer.name + ""  i + 0 SKIP.
   
   /* install trigger */
   ON FIND OF customer OVERRIDE DO:
       i = i + 1.
       DISPLAY "Looking for summer(+1)" i + 0 customer.name + "".
   END.
   
   /* this will fire the trigger */
   FIND NEXT customer.
   DISPLAY "next =" customer.name + "" i + 0 SKIP.
   
   /* this will fire the trigger */
   FIND LAST customer.
   DISPLAY "last =" customer.name + "" i + 0 SKIP.
   
   /* this will fire the trigger */
   FIND PREV customer.
   DISPLAY "prev =" customer.name + "" i + 0 SKIP.
   
   /* this should NOT fire the trigger */
   DISPLAY "can-find(gigi):" 
           IF (CAN-FIND(customer WHERE name EQ "gigi")) THEN "yes" ELSE "nope" SKIP.
   
   /* install 2nd trigger, override the 1st on~ trigger anyway */
   ON FIND OF customer /* override */ DO:
       i = i + 10.
       DISPLAY "Looking for winter (+10)" i + 0 customer.name + "".
   END.
   
   /* guess which one ? */
   FIND FIRST customer.
   DISPLAY "first =" customer.name + "" i + 0 SKIP.
   
   /* NICE - no trigger here */
   FIND CURRENT customer.
   DISPLAY "current =" customer.name + "" i + 0 SKIP.
   
   /* iterations will trigger n times */
   DEFINE VARIABLE j AS INTEGER INIT 0.
   FOR EACH customer:
       j = j + 1.
   END.
   DISPLAY "customer count:" j + 0 "," i + 0 SKIP.

   /* removing trigger: which one ? */
   ON FIND OF customer REVERT.
   
   /* guess which one ? should ne no one */
   FIND FIRST customer.
   DISPLAY "first =" customer.name + "" i + 0 SKIP.


   RETURN TRUE.
END FUNCTION.

MESSAGE do-on-event-tests-1().

